<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: globalhistory.plugin.php 746 2004-10-07 09:37:35Z andrew $
*/

/**
 * @package    MaxPlugins
 * @subpackage Reports
 * @author     Chris Nutting <chris@m3.net>
 * @author     Radek Maciaszek <radek@m3.net>
 */

require_once MAX_PATH . '/plugins/reports/Reports.php';

class Plugins_Reports_Admin_Breakdown extends Plugins_Reports {
    
    // Public info function
    function info()
    {
    	global $strGlobalHistory, $strPluginGlobal, $strDelimiter;
    	
    	include_once MAX_PATH . '/lib/max/Plugins/PluginTranslation.php';
        Max_PluginTranslation::init($this->module, $this->package);
        
    	$plugininfo = array (
    		"plugin-name"			=> Max_PluginTranslation::translate('Agency Breakdown', $this->module, $this->package),
    		"plugin-description"	=> Max_PluginTranslation::translate('Lists Adviews/AdClicks/AdSales totals for a given month',
    		                          $this->module, $this->package),
    		'plugin-category'     => 'admin',
    		'plugin-category-name'	=> Max_PluginTranslation::translate('Admin Reports', $this->module, $this->package),
    		"plugin-author"			=> "Chris Nutting",
    		"plugin-export"			=> "csv",
    		"plugin-authorize"		=> phpAds_Admin,
    		"plugin-import"			=> array (
                "delimiter"		=> array (
                    "title"					=> $strDelimiter,
                    "type"					=> "edit",
                    "size"					=> 1,
                    "default"				=> ","
                    ),
    			"start_date"		=> array (
    				"title"					=> "Start Date",
    				"type"					=> "edit",
    				"size"					=> 10,
    				"default"				=> date("Y/m/d", mktime(0,0,0,date("m")-1, 1, date("Y"))), 
    				),
    			"end_date"		    => array (
    				"title"					=> "End Date",
    				"type"					=> "edit",
    				"size"					=> 10,
    				"default"				=> date("Y/m/d", (mktime(0,0,0,date("m"), 1, date("Y"))) - (24*60*60)), 
    				),
    				
                )
            );
    	
    	return ($plugininfo);
    }
    
    
    
    /*********************************************************/
    /* Private plugin function                               */
    /*********************************************************/
    
    function execute($delimiter=",", $start_date, $end_date)
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        
    	global $date_format;
    	global $strGlobalHistory, $strTotal, $strDay, $strViews, $strClicks, $strCTRShort;
    	$start_date_save = $start_date;
    	$end_date_save = $end_date;
    	$start_date = str_replace('/', '', $start_date);
    	$end_date = str_replace('/', '', $end_date);
    	
    	header ("Content-type: application/csv\nContent-Disposition: inline; filename=agencybreakdown.csv");
    	
    	if(phpAds_isUser(phpAds_Admin))
    	{
    		$res_query = "
                SELECT 
                    g.agencyid AS AgencyId,
                    g.name AS AgencyName,
                    SUM(s.impressions) AS TotalViews,
                    SUM(s.clicks) AS TotalClicks,
                    SUM(s.conversions) AS TotalConversions 
                FROM
                    {$conf['table']['prefix']}{$conf['table']['agency']} AS g,
                    {$conf['table']['prefix']}{$conf['table']['clients']} AS c,
                    {$conf['table']['prefix']}{$conf['table']['campaigns']} AS m,
                    {$conf['table']['prefix']}{$conf['table']['banners']} AS b,
                    {$conf['table']['prefix']}{$conf['table']['data_summary_ad_hourly']} AS s
                WHERE
                    g.agencyid=c.agencyid
                  AND
                    c.clientid=m.clientid
                  AND
                    m.campaignid=b.campaignid
                  AND
                    b.bannerid=s.ad_id
                  AND
                    s.day >= '".$start_date."'
                  AND
                    s.day <= '".$end_date."'
                GROUP BY AgencyId, AgencyName
    		";
    	
    	}
    	
    	$res_banners = phpAds_dbQuery($res_query) or phpAds_sqlDie();
    
    	echo "Agency Breakdown - ".$start_date_save." - ".$end_date_save."\n";
    	echo "AgencyID".$delimiter."Agency Name".$delimiter."Total Views".$delimiter."Total Clicks".$delimiter."Total Sales"."\n";
    	
    	while ($row_banners = phpAds_dbFetchArray($res_banners)) {
    	    echo $row_banners['AgencyId'].$delimiter.$row_banners['AgencyName'].$delimiter.$row_banners['TotalViews'].$delimiter.$row_banners['TotalClicks'].$delimiter.$row_banners['TotalConversions']."\n";
    	}
    	
    	/*
    	while ($row_banners = phpAds_dbFetchArray($res_banners))
    	{
    		$stats [$row_banners['day']]['views'] = $row_banners['adviews'];
    		$stats [$row_banners['day']]['clicks'] = $row_banners['adclicks'];
    		$stats [$row_banners['day']]['sales'] = $row_banners['TotalConversions'];
    	}
    	
    	echo $strGlobalHistory."\n\n";
    	
    	echo $strDay.$delimiter.$strViews.$delimiter.$strClicks.$delimiter.$strCTRShort."\n";
    	
    	$totalclicks = 0;
    	$totalviews = 0;
    	
    	if (isset($stats) && is_array($stats))
    	{
    		for (reset($stats);$key=key($stats);next($stats))
    		{
    			$row = array();
    	
    			//$key = implode('/',array_reverse(split('[-]',$key)));
    			
    			$row[] = $key;
    			$row[] = $stats[$key]['views'];
    			$row[] = $stats[$key]['clicks'];
    			$row[] = phpAds_buildCTR ($stats[$key]['views'], $stats[$key]['clicks']);
    			
    			echo implode ($delimiter, $row)."\n";
    			
    			$totalclicks += $stats[$key]['clicks'];
    			$totalviews += $stats[$key]['views'];
    		}
    	}
    	
    	echo "\n";
    	echo $strTotal.$delimiter.$totalviews.$delimiter.$totalclicks.$delimiter.phpAds_buildCTR ($totalviews, $totalclicks)."\n";
    	*/
    }
}    
?>
